%global gemdir %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gemname xmpp4r
%global geminstdir %{gemdir}/gems/%{gemname}-%{version}
%global rubyabi 1.8


Summary: An XMPP/Jabber library for Ruby
Name: rubygem-%{gemname}
Version: 0.5
Release: 4%{?dist}
Group: Development/Languages
License: GPL+ or Ruby
URL: http://home.gna.org/xmpp4r/
Source0: http://gems.rubyforge.org/gems/%{gemname}-%{version}.gem
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: rubygems
Requires: ruby(abi) = %{rubyabi}
Patch0: rubygem-xmpp4r-examples.patch
Patch1: rubygem-xmpp4r-tests.patch
BuildRequires: rubygems
# So we can run rake test
BuildRequires: rubygem(rake)
BuildArch: noarch
Provides: rubygem(%{gemname}) = %{version}

%description
XMPP4R is an XMPP/Jabber library for Ruby.

%package    doc
Summary:    Documentation for %{name} 
Group:      Documentation
# Directory ownership issue
Requires:   %{name} = %{version}-%{release}

%description    doc
This package contains documentation and examples for %{name}.

%prep

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gemdir}
gem install --local --install-dir %{buildroot}%{gemdir} \
            --force --rdoc %{SOURCE0}

# Files Erroniously installed by the gem.
# They're used in the build process
rm -rf %{buildroot}%{geminstdir}/%{gemname}.gemspec 
rm -rf %{buildroot}%{geminstdir}/setup.rb
rm -rf %{buildroot}%{geminstdir}/tools

# Tidy up the file permissions
# Libraries shouldn't be executable, and the tests aren't run directly ...
find %{buildroot}%{geminstdir}/{test,lib} -type f | \
    xargs chmod 0644
# ... the examples are valid scripts ...    
find %{buildroot}%{geminstdir}/data/doc/%{gemname}/examples \
    -type f -name '*.rb' | xargs chmod 0755
# ... and it's perfectly acceptable for users have read access to the
# source gem
chmod 644 %{buildroot}%{gemdir}/cache/%{gemname}-%{version}.gem

# Find the ruby example scripts where they didn't include a schbang line
pushd %{buildroot}%{geminstdir}/data/doc/xmpp4r/examples
    patch -p1 < %{PATCH0}
popd
# Fix their test cases so they run on fast machines
# and can all be run from simply rake test rather than 1 at a time
pushd %{buildroot}%{geminstdir}
    patch -p1 < %{PATCH1}
popd

# Drop the standalone mode for tests 
# We can't run them way due to missing rubygems required for the tests.
find %{buildroot}%{geminstdir}/{test,lib} -type f | \
    xargs -n 1 sed -i  -e '/^#!\/usr\/.*\/ruby.*/d'

%clean
rm -rf %{buildroot}

%check
pushd %{buildroot}%{geminstdir}/test
rake test
popd

%files
%defattr(-, root, root, -)
%dir %{geminstdir}
%dir %{geminstdir}/data
%{geminstdir}/lib
%doc %{geminstdir}/CHANGELOG
%doc %{geminstdir}/COPYING
%doc %{geminstdir}/LICENSE
%doc %{geminstdir}/README.rdoc
%doc %{geminstdir}/README_ruby19.txt
%{gemdir}/cache/%{gemname}-%{version}.gem
%{gemdir}/specifications/%{gemname}-%{version}.gemspec

%files doc
%defattr(-, root, root, -)
%{geminstdir}/test
%{geminstdir}/data/doc
%{geminstdir}/Rakefile
%{gemdir}/doc/%{gemname}-%{version}

%changelog
* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Feb 02 2010 M Chappell <tremble@tremble.org.uk> - 0.5-3
- Remove redundant Requires from -doc package

* Fri Jan 29 2010 M D Chappell <m.d.chappell@bath.ac.uk> - 0.5-2
- Formatting clean ups
- Fix the test cases
- Replace define with global
- Remove unused macro
- Run the test cases in a check stanza

* Mon Jan 25 2010 M Chappell <m.d.chappell@bath.ac.uk> - 0.5-1
- Initial package
